SoProto(3)

NAME
SoProto - The SoProto class handles PROTO definitions.

SYNOPSIS

#include <Inventor/misc/SoProto.h>

Inherits SoNode.

  Public Member Functions
SoProto (const SbBool externproto=FALSE)
virtual SoType getTypeId (void) const
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.
SoProtoInstance * createProtoInstance (void)
void addISReference (SoNode *container, const SbName &fieldname, const SbName &interfacename)
SbName findISReference (const SoFieldContainer *container, const SbName &fieldname)
void addReference (const SbName &name, SoBase *base)
void removeReference (const SbName &name)
SoBase * findReference (const SbName &name) const
void addRoute (const SbName &fromnode, const SbName &fromfield, const SbName &tonode, const SbName &tofield)
SbName getProtoName (void) const
virtual SbBool readInstance (SoInput *input, unsigned short flags)
virtual void write (SoWriteAction *action)

  Static Public Member Functions
static void setFetchExternProtoCallback (SoFetchExternProtoCB *cb, void *closure)
static SoType getClassTypeId (void)
static SoProto * findProto (const SbName &name)
static void initClass (void)

  Protected Member Functions
virtual ~SoProto ()
virtual void destroy (void)

  Additional Inherited Members

Detailed Description

The SoProto class handles PROTO definitions. SoProto and SoProtoInstance are mostly internal classes. They're designed to read and handle VRML97 PROTOs. However, it's possible to define your PROTOs in C++. You must define your PROTO in a char array, and read that char array using SoInput::setBuffer() and SoDB::readAllVRML(). Example:

char myproto[] =
"#VRML V2.0 utf8
"PROTO ColorCube [
"  field SFColor color 1 1 1
"  field SFVec3f size 1 1 1
"]
"{
"  Shape {
"    appearance Appearance {
"      material Material {
"        diffuseColor IS color
"      }
"    }
"    geometry Box { size IS size }
"  }
"}
"ColorCube { color 1 0 0 size 2 1 1 };
SoInput in;
in.setBuffer(myproto, strlen(myproto));
SoVRMLGroup * protoroot = SoDB::readAllVRML(&in);

Now you can create new instances of the ColorCube PROTO using SoProto::findProto() and SoProto::createProtoInstance(). If you want to insert PROTO instances into your scene graph, you should insert the node returned from SoProtoInstance::getRootNode().

See http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.8 for more information about PROTOs in VRML97.

Constructor & Destructor Documentation

  SoProto::SoProto (const SbBool externproto = FALSE)
Constructor.

  SoProto::~SoProto () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoProto::getTypeId (void) const [virtual]

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting. Usage example:

void foo(SoNode * node)
{
  if (node->getTypeId() == SoFile::getClassTypeId()) {
    SoFile * filenode = (SoFile *)node;  // safe downward cast, knows the type
  }
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the predefined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the top level superclasses for the various class groups.

Implements SoBase.

  SoProto * SoProto::findProto (const SbName & name) [static]
Returns the PROTO definition named name or NULL if not found.

  SoProtoInstance * SoProto::createProtoInstance (void)
Creates an instance of the PROTO.

  void SoProto::addISReference (SoNode * container, const SbName & fieldname, const SbName & interfacename)
Adds an IS reference for this PROTO definition.

  SbName SoProto::findISReference (const SoFieldContainer * container, const SbName & fieldname)
If container is a PROTO definition node with an IS interface field named fieldname, return the interface name, otherwise return an empty SbName.

  void SoProto::addReference (const SbName & name, SoBase * base)
Adds a reference for this PROTO definition.

  void SoProto::removeReference (const SbName & name)
Removes a reference for this PROTO definition.

  SoBase * SoProto::findReference (const SbName & name) const
Finds a reference for this PROTO definition.

  void SoProto::addRoute (const SbName & fromnode, const SbName & fromfield, const SbName & tonode, const SbName & tofield)
Adds a ROUTE for this PROTO definition.

  SbName SoProto::getProtoName (void) const
Returns the PROTO name.

  SbBool SoProto::readInstance (SoInput * in, unsigned short flags) [virtual]
This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

TRUE or FALSE is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning FALSE.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

  void SoProto::write (SoWriteAction * action) [virtual]
Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented from SoNode.

  void SoProto::destroy (void) [protected], [virtual]
Cleans up all hanging references to and from this instance, and then commits suicide.

Called automatically when the reference count goes to zero.

Reimplemented from SoBase.

Author

Generated automatically by Doxygen for Coin from the source code.